/*_############################################################################
  _## 
  _##  SNMP4J - JavaLogAdapterTest.java  
  _## 
  _##  Copyright (C) 2003-2026  Frank Fock (SNMP4J.org)
  _##  
  _##  Licensed under the Apache License, Version 2.0 (the "License");
  _##  you may not use this file except in compliance with the License.
  _##  You may obtain a copy of the License at
  _##  
  _##      http://www.apache.org/licenses/LICENSE-2.0
  _##  
  _##  Unless required by applicable law or agreed to in writing, software
  _##  distributed under the License is distributed on an "AS IS" BASIS,
  _##  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  _##  See the License for the specific language governing permissions and
  _##  limitations under the License.
  _##  
  _##########################################################################*/
package org.snmp4j.log;

import junit.framework.TestCase;

public class JavaLogAdapterTest extends TestCase {

    static LogFactory configuredFactory = LogFactory.getLogFactory();

    @Override
    protected void setUp() throws Exception {
        LogFactory.setLogFactory(new JavaLogFactory());
        super.setUp();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
        LogFactory.setLogFactory(configuredFactory);
    }

    public void testEffectiveLogLevel() {
        LogAdapter loggerABCD = LogFactory.getLogger("a.b.c.d");
        LogAdapter loggerAB = LogFactory.getLogger("a.b");
        loggerAB.setLogLevel(LogLevel.INFO);
        assertEquals(LogLevel.INFO, loggerABCD.getEffectiveLogLevel());
    }

    public void testLogLevel() {
        LogAdapter loggerZBC = LogFactory.getLogger("z.b.c");
        LogAdapter loggerZ = LogFactory.getLogger("z");
        assertEquals(LogLevel.NONE, loggerZBC.getLogLevel());
        loggerZ.setLogLevel(LogLevel.DEBUG);
        loggerZBC.setLogLevel(LogLevel.INFO);
        assertEquals(LogLevel.INFO, loggerZBC.getLogLevel());
        assertEquals(LogLevel.INFO, loggerZBC.getEffectiveLogLevel());
        loggerZBC.setLogLevel(LogLevel.NONE);
        assertEquals(LogLevel.DEBUG, loggerZBC.getEffectiveLogLevel());
    }

    public void testTestGetName() {
        LogAdapter loggerABCD = LogFactory.getLogger("a.b.c.d");
        assertEquals("a.b.c.d", loggerABCD.getName());
    }

}